[john-washam-github]: https://github.com/jwasham
[google-interview-repo]: https://github.com/jwasham/google-interview-university
[travis-repo]: https://travis-ci.org/hpedrorodrigues/C-Algorithms
[travis-badge]: https://travis-ci.org/hpedrorodrigues/C-Algorithms.svg?branch=master

[![Build Status][travis-badge]][travis-repo]

# Algorithms

Part of my daily plan for studying algorithms and data structures in C. Inspired by 
[Google Interview University][google-interview-repo] of 
[John Washam][john-washam-github]. 

## Content

### Data Structures

- [X] ArrayList (Automatically Resizing Vector)
- [X] Linked List (Singly)
- [X] Linked List (Doubly)
- [X] Stack (Array)
- [X] Stack (Linked List)
- [X] Queue (Array)
- [X] Queue (Linked List)
- [ ] Hash Table (Double Hashing)
- [ ] Hash Table (Linear Probing)
- [ ] Hash Table (Quadratic Probing)

### More Knowledge

- [ ] Binary Search
- [ ] Bitwise Operations

### Trees

- [ ] Binary Search Trees: BSTs
- [ ] AVL Tree
- [ ] Splay Tree
- [ ] Red/Black Tree
- [ ] 2-3 Tree
- [ ] 2-3-4 Tree
- [ ] B Tree
- [ ] Heap
- [ ] Priority Queue
- [ ] Binary Heap
- [ ] Traversals: preorder, inorder, postorder, BFS, DFS

### Sorting

- [ ] Selection Sort
- [ ] Insertion Sort
- [ ] Heap Sort
- [ ] Quick Sort
- [ ] Merge Sort

### Graphs

- [ ] Directed Graph
- [ ] Undirected Graph
- [ ] Adjacency matrix
- [ ] Adjacency list
- [ ] Traversals: BFS, DFS
